commit ee143587852f7a6937a6997da730b4e02e427fc4
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Sun Dec 14 18:23:37 2025 +0000

    xclient module

diff --git a/src/OS/Makefile-Base b/src/OS/Makefile-Base
index f713ad3ca..9f26eff0f 100644
--- a/src/OS/Makefile-Base
+++ b/src/OS/Makefile-Base
@@ -541,8 +541,7 @@ OBJ_WITH_CONTENT_SCAN = malware.o mime.o regex.o spam.o spool_mbox.o
 OBJ_EXPERIMENTAL =	dane.o \
 			dcc.o \
 			imap_utf7.o \
-			utf8.o \
-			xclient.o
+			utf8.o
 
 # Targets for final binaries; the main one has a build number which is
 # updated each time. We don't bother with that for the auxiliaries.
@@ -939,7 +938,6 @@ dane.o:		$(HDRS) dane.c dane-openssl.c
 dcc.o:		$(HDRS) dcc.h dcc.c
 imap_utf7.o:	$(HDRS) imap_utf7.c
 utf8.o:		$(HDRS) utf8.c
-xclient.o:	$(HDRS) xclient.c
 
 # The module containing tables of available lookups, routers, auths, and
 # transports must be rebuilt if any of them are. However, because the makefiles
diff --git a/src/scripts/Configure-Makefile b/src/scripts/Configure-Makefile
index 82e93d2ad..9a7351482 100755
--- a/src/scripts/Configure-Makefile
+++ b/src/scripts/Configure-Makefile
@@ -332,7 +332,7 @@ done <<-END
  routers    ROUTER	ACCEPT DNSLOOKUP IPLITERAL IPLOOKUP MANUALROUTE QUERYPROGRAM REDIRECT
  transports TRANSPORT	APPENDFILE AUTOREPLY LMTP PIPE QUEUEFILE SMTP
  auths	    AUTH	CRAM_MD5 CYRUS_SASL DOVECOT EXTERNAL GSASL HEIMDAL_GSSAPI PLAINTEXT SPA TLS
- miscmods   SUPPORT	ARC _DKIM DMARC DMARC_NATIVE DSCP _EXIM_FILTER PAM PERL RADIUS _SIEVE_FILTER SOCKS SPF SPF_PERL
+ miscmods   SUPPORT	ARC _DKIM DMARC DMARC_NATIVE DSCP _EXIM_FILTER PAM PERL RADIUS _SIEVE_FILTER SOCKS SPF SPF_PERL XCLIENT
 END
 
 # See if there is a definition of EXIM_PERL in what we have built so far.
diff --git a/src/scripts/MakeLinks b/src/scripts/MakeLinks
index 1875c6963..642cd7302 100755
--- a/src/scripts/MakeLinks
+++ b/src/scripts/MakeLinks
@@ -109,7 +109,8 @@ for f in dummy.c \
 	radius.c radius_api.h \
 	sieve_filter.c sieve_filter_api.h \
 	socks.c socks_api.h \
-	spf.c spf_perl.c spf.h spf_api.h
+	spf.c spf_perl.c spf.h spf_api.h \
+	xclient.c xclient_api.h
 do
   ln -s ../../src/$d/$f `basename $f`
 done
@@ -158,7 +159,7 @@ done
 
 # EXPERIMENTAL_*
 for f in  dcc.c dcc.h dane.c dane-openssl.c \
-  danessl.h imap_utf7.c utf8.c xclient.c
+  danessl.h imap_utf7.c utf8.c
 do
   ln -s ../src/$f $f
 done
diff --git a/src/src/EDITME b/src/src/EDITME
index 695cceafd..9e5b25029 100644
--- a/src/src/EDITME
+++ b/src/src/EDITME
@@ -707,7 +707,8 @@ DISABLE_MAL_MKS=yes
 # Uncomment the following line to add SRV smtps support
 # EXPERIMENTAL_SRV_SMTPS=yes
 #
-# Uncomment the following line to add XCLIENT support
+# Uncomment the following line to add XCLIENT support.
+# Set to 2 for a dynamic-load module.
 # EXPERIMENTAL_XCLIENT=yes
 
 ###############################################################################
diff --git a/src/src/drtables.c b/src/src/drtables.c
index 3c714ba24..4df612c65 100644
--- a/src/src/drtables.c
+++ b/src/src/drtables.c
@@ -498,24 +498,28 @@ extern misc_module_info arc_module_info;
 #if defined(SUPPORT_DSCP) && SUPPORT_DSCP!=2
 extern misc_module_info dscp_module_info;
 #endif
-#if defined(RADIUS_CONFIG_FILE) && (!defined(SUPPORT_RADIUS) || SUPPORT_RADIUS!=2)
-extern misc_module_info radius_module_info;
-#endif
 #if defined(SUPPORT_PAM) && SUPPORT_PAM!=2
 extern misc_module_info pam_module_info;
 #endif
 #if defined(EXIM_PERL) && (!defined(SUPPORT_PERL) || SUPPORT_PERL!=2)
 extern misc_module_info perl_module_info;
 #endif
+#if defined(RADIUS_CONFIG_FILE) && (!defined(SUPPORT_RADIUS) || SUPPORT_RADIUS!=2)
+extern misc_module_info radius_module_info;
+#endif
+#if defined(SUPPORT_SOCKS) && SUPPORT_SOCKS!=2
+extern misc_module_info socks_module_info;
+#endif
+#if defined(EXPERIMENTAL_XCLIENT) && EXPERIMENTAL_XCLIENT!=2
+extern misc_module_info xclient_module_info;
+#endif
+
 #if !defined(DISABLE_EXIM_FILTER) && (!defined(SUPPORT_EXIM_FILTER) || SUPPORT_EXIM_FILTER!=2)
 extern misc_module_info exim_filter_module_info;
 #endif
 #if !defined(DISABLE_SIEVE_FILTER) && (!defined(SUPPORT_SIEVE_FILTER) || SUPPORT_SIEVE_FILTER!=2)
 extern misc_module_info sieve_filter_module_info;
 #endif
-#if defined(SUPPORT_SOCKS) && SUPPORT_SOCKS!=2
-extern misc_module_info socks_module_info;
-#endif
 
 void
 init_misc_mod_list(void)
@@ -543,6 +547,9 @@ onetime = TRUE;
 #if defined(SUPPORT_PAM) && SUPPORT_PAM!=2
   misc_mod_add(&pam_module_info);
 #endif
+#if defined(EXPERIMENTAL_XCLIENT) && EXPERIMENTAL_XCLIENT!=2
+  misc_mod_add(&xclient_module_info);
+#endif
 #if defined(EXIM_PERL) && (!defined(SUPPORT_PERL) || SUPPORT_PERL!=2)
   misc_mod_add(&perl_module_info);
 #endif
diff --git a/src/src/exim.h b/src/src/exim.h
index 4bd0a87e7..7b4270cad 100644
--- a/src/src/exim.h
+++ b/src/src/exim.h
@@ -561,9 +561,6 @@ config.h, mytypes.h, and store.h, so we don't need to mention them explicitly.
 #ifdef SUPPORT_DSCP
 # include "miscmods/dscp_api.h"
 #endif
-#ifdef RADIUS_CONFIG_FILE
-# include "miscmods/radius_api.h"
-#endif
 #ifdef SUPPORT_PAM
 # include "miscmods/pam_api.h"
 #endif
@@ -573,6 +570,12 @@ config.h, mytypes.h, and store.h, so we don't need to mention them explicitly.
 #ifdef SUPPORT_SOCKS
 # include "miscmods/socks_api.h"
 #endif
+#ifdef RADIUS_CONFIG_FILE
+# include "miscmods/radius_api.h"
+#endif
+#ifdef EXPERIMENTAL_XCLIENT
+# include "miscmods/xclient_api.h"
+#endif
 #include "miscmods/exim_filter_api.h"
 #include "miscmods/sieve_filter_api.h"
 
diff --git a/src/src/functions.h b/src/src/functions.h
index 4e56c14a4..f07799321 100644
--- a/src/src/functions.h
+++ b/src/src/functions.h
@@ -706,10 +706,6 @@ extern BOOL    write_chunk(transport_ctx *, const uschar *, int);
 extern ssize_t write_to_fd_buf(int, const uschar *, size_t);
 extern uschar *wrap_header(const uschar *, unsigned, unsigned, const uschar *, unsigned);
 
-#ifdef EXPERIMENTAL_XCLIENT
-extern uschar * xclient_smtp_command(uschar *, int *, BOOL *);
-extern gstring * xclient_smtp_advertise_str(gstring *);
-#endif
 extern uschar *xtextencode(const uschar *, int);
 extern int     xtextdecode(const uschar *, uschar **);
 
diff --git a/src/src/miscmods/Makefile b/src/src/miscmods/Makefile
index a5fbba441..f731088ba 100644
--- a/src/src/miscmods/Makefile
+++ b/src/src/miscmods/Makefile
@@ -43,14 +43,15 @@ dmarc_native.o dmarc_native.so:	$(HDRS) spf.h pdkim.h dmarc.h \
 				dmarc_native.c dmarc_common.c
 dscp.o  dscp.so:		$(HDRS) dscp.c
 dummy.o:			dummy.c
-exim_filter.o exim_filter.so:	$(HDRS) exim_filter.c
-pam.o   pam.so:			$(HDRS) pam.c
-perl.o perl.so:         	$(HDRS) perl.c
-radius.o radius.so:		$(HDRS) radius.c
-sieve_filter.o sieve_filter.so:	$(HDRS) sieve_filter.c
-socks.o socks.so:		$(HDRS) socks_api.h ../transports/smtp.h socks.c
-spf.o   spf.so:			$(HDRS) spf.h spf.c
-spf_perl.o spf_perl.so:		$(HDRS) spf.h spf_perl.c
+exim_filter.o	exim_filter.so:	$(HDRS) exim_filter.c
+pam.o   	pam.so:		$(HDRS) pam.c
+perl.o		perl.so:       	$(HDRS) perl.c
+radius.o	radius.so:	$(HDRS) radius.c
+sieve_filter.o	sieve_filter.so: $(HDRS) sieve_filter.c
+socks.o		socks.so:	$(HDRS) socks_api.h ../transports/smtp.h socks.c
+spf.o   	spf.so:		$(HDRS) spf.h spf.c
+spf_perl.o	spf_perl.so:	$(HDRS) spf.h spf_perl.c
+xclient.o	xclient.so:	$(HDRS) xclient_api.h xclient.c
 
 
 
diff --git a/src/src/miscmods/xclient.c b/src/src/miscmods/xclient.c
new file mode 100644
index 000000000..77bf743a4
--- /dev/null
+++ b/src/src/miscmods/xclient.c
@@ -0,0 +1,356 @@
+/*************************************************
+*     Exim - an Internet mail transport agent    *
+*************************************************/
+
+/* Copyright (c) The Exim Maintainers 2023 - 2025 */
+/* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-or-later */
+
+#include "../exim.h"
+
+#ifdef EXPERIMENTAL_XCLIENT
+
+/* This is a proxy protocol.
+
+From https://www.postfix.org/XCLIENT_README.html I infer two generations of
+protocol.  The more recent one obviates the utility of the HELO attribute, since
+it mandates the proxy always sending a HELO/EHLO smtp command following (a
+successful) XCLIENT command, and that will carry a NELO name (which we assume,
+though it isn't specified, will be the actual one presented to the proxy by the
+possibly-new client).  The same applies to the PROTO attribute. */
+
+# define XCLIENT_V2
+
+enum xclient_cmd_e {
+  XCLIENT_CMD_UNKNOWN,
+  XCLIENT_CMD_ADDR,
+  XCLIENT_CMD_NAME,
+  XCLIENT_CMD_PORT,
+  XCLIENT_CMD_LOGIN,
+  XCLIENT_CMD_DESTADDR,
+  XCLIENT_CMD_DESTPORT,
+# ifdef XCLIENT_V1
+  XCLIENT_CMD_HELO,
+  XCLIENT_CMD_PROTO,
+# endif
+};
+
+struct xclient_cmd {
+  const uschar *	str;
+  unsigned		len;
+} xclient_cmds[] = {
+  [XCLIENT_CMD_UNKNOWN] = { NULL },
+  [XCLIENT_CMD_ADDR] =	{ US"ADDR",  4 },
+  [XCLIENT_CMD_NAME] =	{ US"NAME",  4 },
+  [XCLIENT_CMD_PORT] =	{ US"PORT",  4 },
+  [XCLIENT_CMD_LOGIN] =	{ US"LOGIN", 5 },
+  [XCLIENT_CMD_DESTADDR] =	{ US"DESTADDR", 8 },
+  [XCLIENT_CMD_DESTPORT] =	{ US"DESTPORT", 8 },
+# ifdef XCLIENT_V1
+  [XCLIENT_CMD_HELO] =	{ US"HELO",  4 },
+  [XCLIENT_CMD_PROTO] =	{ US"PROTO", 5 },
+# endif
+};
+
+/*************************************************
+*          XCLIENT proxy implementation          *
+*************************************************/
+
+/* Arguments:
+  code        points to the coded string
+  end         points to the end of coded string
+  ptr         where to put the pointer to the result, which is in
+              dynamic store
+Returns:      the number of bytes in the result, excluding the final zero;
+              -1 if the input is malformed
+*/
+
+static int
+xclient_xtextdecode(const uschar * code, const uschar * end, uschar ** ptr)
+{
+return xtextdecode(string_copyn(code, end-code), ptr);
+}
+
+/*************************************************
+*   Check XCLIENT line and set sender_address    *
+*************************************************/
+
+
+/* Check the format of a XCLIENT line.
+Arguments:
+  s       	the data portion of the line (already past any white space)
+  resp		result: smtp respose code
+  flagp		input: helo seen  output: fail is fatal
+
+Return: NULL on success, or error message
+*/
+
+# define XCLIENT_UNAVAIL     US"[UNAVAILABLE]"
+# define XCLIENT_TEMPUNAVAIL US"[TEMPUNAVAIL]"
+
+static uschar *
+xclient_smtp_command(const uschar * s, int * resp, BOOL * flagp)
+{
+const uschar * word = s;
+uschar * errmsg = NULL;
+enum {
+  XCLIENT_READ_COMMAND = 0,
+  XCLIENT_READ_VALUE,
+  XCLIENT_SKIP_SPACES
+} state = XCLIENT_SKIP_SPACES;
+enum xclient_cmd_e cmd;
+static BOOL xc_proxy_session = FALSE;
+
+if (  !*flagp
+   && verify_check_host(&hosts_require_helo) == OK)
+  {
+  *resp = 503;
+  *flagp= FALSE;
+  return US"no HELO/EHLO given";
+  }
+
+/* If already in a proxy session, do not re-check permission. */
+
+if (!xc_proxy_session && verify_check_host(&hosts_xclient) == FAIL)
+  {
+  *resp = 501;
+  *flagp= TRUE;
+  return US"XCLIENT command used when not advertised";
+  }
+
+if (sender_address)
+  {
+  *resp = 503;
+  *flagp= FALSE;
+  return US"mail transaction in progress";
+  }
+
+if (!*word)
+  {
+  errmsg = US"XCLIENT must have at least one operand";
+  goto fatal_501;
+  }
+
+for (state = XCLIENT_SKIP_SPACES; *s; )
+  switch (state)
+    {
+    case XCLIENT_READ_COMMAND:
+      {
+      int len;
+
+      word = s;
+      while (*s && *s != '=') s++;
+      len = s - word;
+      if (!*s)
+	{
+	errmsg = string_sprintf("XCLIENT: missing value for parameter '%.*s'",
+			  len, word);
+	goto fatal_501;
+	}
+
+      DEBUG(D_transport) debug_printf(" XCLIENT: cmd %.*s\n", len, word);
+      cmd = XCLIENT_CMD_UNKNOWN;
+      for (struct xclient_cmd * x = xclient_cmds + 1;
+	   x < xclient_cmds + nelem(xclient_cmds); x++)
+	if (len == x->len && strncmpic(word, x->str, len) == 0)
+	  {
+	  cmd = x - xclient_cmds;
+	  break;
+	  }
+      if (cmd == XCLIENT_CMD_UNKNOWN)
+	{
+	errmsg = string_sprintf("XCLIENT: unrecognised parameter '%.*s'",
+			  len, word);
+	goto fatal_501;
+	}
+      state = XCLIENT_READ_VALUE;
+      }
+      break;
+
+    case XCLIENT_READ_VALUE:
+      {
+      int old_pool = store_pool;
+      int len;
+      uschar * val;
+
+      word = ++s;			/* skip the = */
+      Uskip_nonwhite(&s);
+      len = s - word;
+
+      DEBUG(D_transport) debug_printf(" XCLIENT: \tvalue %.*s\n", len, word);
+      if (len == 0)
+	{ errmsg = US"XCLIENT: zero-length value for param"; goto fatal_501; }
+
+      if (  len == 13
+	 && (  strncmpic(word, XCLIENT_UNAVAIL, 13) == 0
+	    || strncmpic(word, XCLIENT_TEMPUNAVAIL, 13) == 0
+	 )  )
+	val = NULL;
+
+      else if ((len = xclient_xtextdecode(word, s, &val)) == -1)
+	{
+	errmsg = string_sprintf("failed xtext decode for XCLIENT: '%.*s'", len, word);
+	goto fatal_501;
+	}
+
+      store_pool = POOL_PERM;
+      switch (cmd)
+	{
+	case XCLIENT_CMD_ADDR:
+	  proxy_local_address = sender_host_address;
+	  sender_host_address = val ? string_copyn(val, len) : NULL;
+	  break;
+	case XCLIENT_CMD_NAME:
+	  sender_host_name = val ? string_copyn(val, len) : NULL;
+	  break;
+	case XCLIENT_CMD_PORT:
+	  proxy_local_port = sender_host_port;
+	  sender_host_port = val ? Uatoi(val) : 0;
+	  break;
+	case XCLIENT_CMD_DESTADDR:
+	  proxy_external_address = val ? string_copyn(val, len) : NULL;
+	  break;
+	case XCLIENT_CMD_DESTPORT:
+	  proxy_external_port = val ? Uatoi(val) : 0;
+	  break;
+
+	case XCLIENT_CMD_LOGIN:
+	  if (val)
+	    {
+	    authenticated_id = string_copyn(val, len);
+	    sender_host_authenticated = US"xclient";
+	    authentication_failed = FALSE;
+	    }
+	  else
+	    {
+	    authenticated_id = NULL;
+	    sender_host_authenticated = NULL;
+	    }
+	  break;
+
+# ifdef XCLIENT_V1
+	case XCLIENT_CMD_HELO:
+	  sender_helo_name = val ? string_copyn(val, len) : NULL;
+	  break;
+	case XCLIENT_CMD_PROTO:
+	  if (!val)
+	    { store_pool = old_pool; errmsg = US"missing proto for XCLIENT"; goto fatal_501; }
+	  else if (len == 4 && strncmpic(val, US"SMTP", 4) == 0)
+	    *esmtpflag = FALSE;	/* function arg */
+	  else if (len == 5 && strncmpic(val, US"ESMTP", 5) == 0)
+	    *esmtpflag = TRUE;
+	  else
+	    { store_pool = old_pool; errmsg = US"bad proto for XCLIENT"; goto fatal_501; }
+	  break;
+# endif
+	default: break;	/* stupid compiler silencing */
+	}
+      store_pool = old_pool;
+      state = XCLIENT_SKIP_SPACES;
+      break;
+      }
+
+    case XCLIENT_SKIP_SPACES:
+      Uskip_whitespace(&s);
+      state = XCLIENT_READ_COMMAND;
+      break;
+
+    default:
+      errmsg = US"unhandled XCLIENT parameter type";
+      goto fatal_501;
+    }
+
+if (!proxy_local_address)
+  { errmsg = US"missing ADDR for XCLIENT"; goto fatal_501; }
+if (!proxy_local_port)
+  { errmsg = US"missing PORT for XCLIENT"; goto fatal_501; }
+if (state != XCLIENT_SKIP_SPACES)
+  { errmsg = US"bad state parsing XCLIENT parameters"; goto fatal_501; }
+
+host_build_sender_fullhost();
+proxy_session = TRUE;		/* global */
+xc_proxy_session = TRUE;	/* local */
+*resp = 220;
+return NULL;
+
+fatal_501:
+  *flagp= TRUE;
+  *resp = 501;
+  return errmsg;
+}
+
+# undef XCLIENT_UNAVAIL
+# undef XCLIENT_TEMPUNAVAIL
+
+
+/*API*/
+static gstring *
+xclient_smtp_advertise_str(gstring * g)
+{
+g = string_catn(g, US"-XCLIENT ", 8);
+for (int i = 1; i < nelem(xclient_cmds); i++)
+  {
+  g = string_catn(g, US" ", 1);
+  g = string_cat(g, xclient_cmds[i].str);
+  }
+return string_catn(g, US"\r\n", 2);
+}
+
+
+/*API
+Return: true if the cmd was good and the protocol started
+*/
+
+static int
+xclient_protocol_start(const uschar * smtp_cmd_data, int * donep,
+  BOOL helo_seen)
+{
+BOOL fatal = helo_seen;
+uschar * errmsg;
+int resp;
+
+if (!(errmsg = xclient_smtp_command(smtp_cmd_data, &resp, &fatal)))
+  {
+  /*XXX unclear in spec. if this needs to be an ESMTP banner,
+  nor whether we get the original client's HELO after (or a proxy fake).
+  We require that we do; the following HELO/EHLO handling will set
+  sender_helo_name as normal. */
+
+  smtp_printf("%d XCLIENT success\r\n", SP_NO_MORE, resp);
+  return TRUE;
+  }
+else if (fatal)
+  *donep = synprot_error(L_smtp_syntax_error, resp, NULL, errmsg);
+else
+  {
+  smtp_printf("%d %s\r\n", SP_NO_MORE, resp, errmsg);
+  log_write(0, LOG_MAIN|LOG_REJECT, "rejected XCLIENT from %s: %s",
+    host_and_ident(FALSE), errmsg);
+  }
+  
+return FALSE;
+}
+
+/******************************************************************************/
+/* Module API */
+
+static void * xclient_functions[] = {
+  [XCLIENT_PROTO_ADVERTISE] =	(void *) xclient_smtp_advertise_str,
+  [XCLIENT_PROTO_START] =	(void *) xclient_protocol_start,
+};
+
+misc_module_info xclient_module_info =
+{
+  .name =		US"xclient",
+# ifdef DYNLOOKUP
+  .dyn_magic =		MISC_MODULE_MAGIC,
+# endif
+  .functions =		xclient_functions,
+  .functions_count =	nelem(xclient_functions),
+};
+#endif	/*EXPERIMENTAL_XCLIENT*/
+
+/* vi: aw ai sw=2
+*/
+/* End of xclient.c */
+
diff --git a/src/src/miscmods/xclient_api.h b/src/src/miscmods/xclient_api.h
new file mode 100644
index 000000000..e59296395
--- /dev/null
+++ b/src/src/miscmods/xclient_api.h
@@ -0,0 +1,15 @@
+/*************************************************
+*     Exim - an Internet mail transport agent    *
+*************************************************/
+
+/* Copyright (c) The Exim Maintainers 2025 */
+/* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-or-later */
+
+/* API definitions for the proxy-protocol module */
+
+
+/* Function table entry numbers */
+
+#define	XCLIENT_PROTO_ADVERTISE	0
+#define	XCLIENT_PROTO_START	1
diff --git a/src/src/smtp_in.c b/src/src/smtp_in.c
index d694c8d7a..222fc5b93 100644
--- a/src/src/smtp_in.c
+++ b/src/src/smtp_in.c
@@ -3811,6 +3811,9 @@ smtp_setup_msg(void)
 int done = 0;
 BOOL toomany = FALSE, discarded = FALSE, last_was_rej_mail = FALSE,
     last_was_rcpt = FALSE;
+#ifdef EXPERIMENTAL_XCLIENT
+static misc_module_info * xclient_mi = NULL;
+#endif
 rmark reset_point = store_mark();
 
 DEBUG(D_receive) debug_printf("smtp_setup_msg entered\n");
@@ -4433,8 +4436,17 @@ while (done <= 0)
 #ifdef EXPERIMENTAL_XCLIENT
 	if (proxy_session || verify_check_host(&hosts_xclient) != FAIL)
 	  {
+	  uschar * dummy_errmsg;
+	  typedef gstring * (*fn_t) (gstring *);
+
+	  if (  !xclient_mi
+	     && !(xclient_mi = misc_mod_find(US"xclient", &dummy_errmsg)))
+	    {
+	    smtp_closedown(US"Temporary local problem - please try later");
+	    return FALSE;
+	    }
 	  g = string_catn(g, smtp_code, 3);
-	  g = xclient_smtp_advertise_str(g);
+	  g = ((fn_t *) xclient_mi->functions)[XCLIENT_PROTO_ADVERTISE] (g);
 	  }
 #endif
 #ifndef DISABLE_PRDR
@@ -4516,37 +4528,21 @@ while (done <= 0)
 
 #ifdef EXPERIMENTAL_XCLIENT
     case XCLIENT_CMD:
-      {
-      BOOL fatal = fl.helo_seen;
-      uschar * errmsg;
-      int resp;
-
       HAD(SCH_XCLIENT);
       smtp_mailcmd_count++;
 
-      if ((errmsg = xclient_smtp_command(smtp_cmd_data, &resp, &fatal)))
-	if (fatal)
-	  done = synprot_error(L_smtp_syntax_error, resp, NULL, errmsg);
-	else
-	  {
-	  smtp_printf("%d %s\r\n", SP_NO_MORE, resp, errmsg);
-	  log_write(0, LOG_MAIN|LOG_REJECT, "rejected XCLIENT from %s: %s",
-	    host_and_ident(FALSE), errmsg);
-	  }
+      if (!xclient_mi)
+	done = synprot_error(L_smtp_syntax_error, 501, NULL,
+	  US"XCLIENT command used when not advertised");
       else
 	{
-	fl.helo_seen = FALSE;			/* Require another EHLO */
-	smtp_code = string_sprintf("%d", resp);
-
-	/*XXX unclear in spec. if this needs to be an ESMTP banner,
-	nor whether we get the original client's HELO after (or a proxy fake).
-	We require that we do; the following HELO/EHLO handling will set
-	sender_helo_name as normal. */
-
-	smtp_printf("%s XCLIENT success\r\n", SP_NO_MORE, smtp_code);
+	typedef BOOL (*fn_t) (const uschar *, int *, BOOL);
+	BOOL started = ((fn_t *) xclient_mi->functions)[XCLIENT_PROTO_START]
+					  (smtp_cmd_data, &done, fl.helo_seen);
+	if (started)
+	  fl.helo_seen = FALSE;			/* Require another EHLO */
 	}
       break; /* XCLIENT */
-      }
 #endif
 
 

